param(   $startdir  =  "C:\users\"    )
#
function Check-Header
{
       param(
             $path
       )
       # Get content of each file (up to 8 bytes) for analysis
       ([Byte[]] $fileheader = Get-Content -force  -Path $path -TotalCount 8 -Encoding Byte    ) |
       ForEach-Object {
             if( $_ -lt 16)
             {
                   $HeaderAsHexString += "0{0:X}" -f $_ 
             }
             else
             {
                   $HeaderAsHexString += "{0:X}" -f $_
             }
       }

return($HeaderAsHexString)
}

function Get-FileHeader
{
       param(
             $Extens
       )
       # Hexidecimal signatures for expected files
                 $exts =  @{ ".pdf"  = '25504446';  ".tiff" = '492049';    ".docx" = "504B0304"}

if   ( $exts.ContainsKey($Extens) )
     {
              return (     $exts.Get_Item($Extens) ); 
     } 
return(-1)  
}

write-host "Scanning disk from:  "
write-host $startdir
write-host "---------------------------------------------------------------------"
write-host "-- use -startdir to change scan location ----------------"
write-host "---------------------------------------------------------------------"

 # main extract file objects   

$x=(get-childitem $startdir   -recurse -Include  *.docx,*.pdf -ErrorAction SilentlyContinue | select-object FullName, name, extension)
foreach ($y in $x) 
{ 
# for each get extension
$z=  $y.extension 

# set to invalid and check length of return 
$ValidFileHeader = -1
if ( $z.length -ge 2 )
{
#  get valid file header for that file type
$ValidFileHeader = FileHeader($z)
}
# if we have a good valid signature
if (  $ValidFileHeader -ne -1 )
   {
    # check the first n bytes of file header contain valid signature
   $ValidFileHeader = "^" +  $ValidFileHeader 
   $ActualFileHeader  = Check-Header ($y.fullname)
   
             # if not a Valid file header
    if  (   $ActualFileHeader -match  $ValidFileHeader )
         {
         # write-host "valid" 
          }
     else
         {
          # found an invalid file
          write-host "invalid" 
          $y.fullname
          $z
          $ValidFileHeader 
          $ActualFileHeader
         }
    }

 #end loop
} 

