<#

.SYNOPSIS

Powershell version of Unix Diff command


.DESCRIPTION

Powershell version of Unix Diff command

See:
 PowerShell for Malware Incident Response    Amazon Kindle eBook by MARK OSBORNE

.PARAMETER   $file1
Master file in compare



.PARAMETER   $file2
compared file in compare



.EXAMPLE

ps-diff.ps1 



#>
# 
param(   $file1, $file2 )
#


Write-host "Ps-Diff - Powershell version of Unix Diff command"
Write-host "Author: Mark Osborne"
Write-host "--------------------------------------------------------"


 # validate file 1 object
If    ( ! $file1  )  {
write-host "File1 cannot be null"
exit
}


If    ( ! (test-path $file1 )  ) {
write-host "File not found :  "  $file1

exit
}

 # validate file2 objects
If    ( ! $file2 )  {
write-host "File2 cannot be null"

exit
}


If    ( ! (test-path $file2 )  ) {
write-host "File not found :  "  $file2 

exit
}
$bb =  (Get-Content -path  $file1 )
$cc =   (Get-Content -path  $file2 )
$dd = ( $bb.count + $cc.count ) / 3
if  ( $dd -le 100 ) 
     {
     $dd = 100
     }

Compare-Object $bb $cc  -syncwindow $dd



# Compare-Object (Get-Content -path .\Desktop\next-book\NewDocument.txt) (Get-Content -path .\Desktop\next-book\NewDocument2.txt)
