
<#

.SYNOPSIS

Powershell head command

.DESCRIPTION

 This cmdlet is a Powershell head command

See:
 PowerShell for Malware Incident Response    Amazon Kindle eBook by MARK OSBORNE

.PARAMETER   $l
No of lines to list

This is an optional parameter.

.PARAMETER   $file
file to list 


.EXAMPLE

ps-head.ps1 -l 10 myfile

List first ten lines of myfile
#>
# [CmdletBinding()]
param(   
[string] $l = $null   , 
 [string] $file = $null )
#
if   (  ! $l  )   {
Write "-file or -l cannot be null"
write "usage:"
Write "ps-head -l number  -file file"
exit
}
if   ( !( $l -match "[0-9]" ) )   {
Write "-l must be numeric"
write "usage:"
Write "ps-head -l number file"
exit
}

 # validate file  object
If    (  ! $file )  {
Write "-file or -l cannot be null"
exit
}
If    ( ! (test-path $file)  ) {
write-host "File not found :  "  $file

exit
}


Write-host "Ps-head  - Windows head command "
Write-host "Author: Mark Osborne"
Write-host "--------------------------------------------------------"
get-content  $file -totalCount $l

 # get-content  $file | select-object -first $l
