<#

.SYNOPSIS

Powershell listing of files that "hidden executables"


.DESCRIPTION

Powershell listing of files that "hidden executables"
They have a file magic 4D5A but have extention which 
isnt exe or com or dll

See:
 PowerShell for Malware Incident Response    Amazon Kindle eBook by MARK OSBORNE

.EXAMPLE

ps-misidentity.ps1   c:\temp

Process c:\temp

.EXAMPLE

ps-misidentity.ps1 

Process all disk


#>

#
param(   $dir  =  "C:\"    )
 

Write-host "Ps-missidentity "
Write-host "Author: Mark Osborne"
Write-host "--------------------------------------------------------"
 

#
function Check-Header
{
       param(
             $path
       )
       # Get content of each file (up to 8 bytes) for analysis
       ([Byte[]] $fileheader = Get-Content -force  -Path $path -TotalCount 8 -Encoding Byte ) |
       ForEach-Object {
             if( $_ -lt 16)
             {
                   $HeaderAsHexString += "0{0:X}" -f $_ 
             }
             else
             {
                   $HeaderAsHexString += "{0:X}" -f $_
             }
       }

return($HeaderAsHexString)
}


If ( -not ( test-path $dir ))
{
write-host "Invalid path specified"
exit
}


 # main extract file objects   
 
$x = get-childitem $dir   -recurse -exclude  *.exe,*.dll,*.com -ErrorAction SilentlyContinue | where { $_.GetType().Name -eq "FileInfo" } | select-object FullName, name, extension
foreach ($y in $x) 
{ 
# for each get extension
$z=  $y.extension 
#  get valid file header for that file type
$ValidFileHeader = "4D5A"
#
   # check the first n bytes of file header contain valid signature
   $ValidFileHeader = "^" +  $ValidFileHeader 
   $ActualFileHeader  = Check-Header ($y.fullname)
   
             # if a Valid file header
    if  (   $ActualFileHeader -match  $ValidFileHeader )
         {
         write-host "Hidden executable" $y.fullname $ActualFileHeader
         
          }
     else
         {
          # found an invalid file
        #  write-host "invalid" 
        #  $y.fullname
        #  $z
        #  $ValidFileHeader 
       #   $ActualFileHeader
         }
    

 #end loop
} 

