<#
.SYNOPSIS

Powershell mkhashdb command

.DESCRIPTION

The ps-mkhashdb generates sha-1 check sums of the sysroot on  a clean computer

Author: Mark Osborne


.PARAMETER file

The file name of a file to be processed. 

.PARAMETER dir

The dir name to be processed. 

.EXAMPLE

 ps-hashdiff   

#uses  c:\windows (whole file tree)  AND 	generates sha1 hash in db for each file


#>

param(   $dir  ,   $file     )
#

function Usage
   {
   write-host "Usage:"
   write-host "              ps-hashdiff -dir dir-name -file file-name                   "
   write-host "-----------------------------------------------------------"
   }
 # validate file objects   

If    ( $dir -eq $null )  {
    $sysroot = $env:SystemRoot 
    }
If    ( $file -eq $null )  {
    $file  = "*"
    $sysroot += "\" +  $file
    }
else
   {
   $sysroot += "\" +  $file
   If    ( ! (test-path $sysroot )  ) {
        write-host "File not found"
       Usage
       exit 
       }
   }
$t = 0


write-host  "ps-mkhashdb - file integrity checker   database generator               "
write-host  "Author: Mark Osborne             "
write-host  "---------------------------------------------------------------------------               "
$x = Get-Childitem $sysroot -Include *.dll,*.exe,*.sys  -recurse  -force  -erroraction silentlycontinue | Select-Object fullname
 for ( $i = 0 ; $i -lt  $x.count ; $i++ ) {
      $hash = Get-FileHash   -algorithm sha1  $x[$i].FullName
      $x[$i] |  add-member -membertype noteproperty -name Hash -value $hash.hash
 }
$x | export-csv hashdb.csv

 