<#
.SYNOPSIS

Powershell equivalent of Unix "od" command

.DESCRIPTION

The ps-od is the Powershell equivalent of Unix  "od"command.  Youngster will not know the "od" command but might know it as "xxd". It produces a hex dump of the file


See:
 PowerShell for Malware Incident Response    Amazon Kindle eBook by MARK OSBORNE

.PARAMETER file

The file name of a file to be processed. 

.EXAMPLE

ps-od -file helloworld.exe

#>

param(   $file  ,  $max=0  )
#

function Usage
{

write-host "Usage:"
write-host "              ps-od -file file-name                   "
write-host "-----------------------------------------------------------"

}
 # validate file objects   
If    ( !  $file  )  {
write-host "File cannot be null"
Usage
exit 
}


If    ( ! (test-path $file )  ) {
write-host "File not found"
Usage
exit 
}
$loop_cnt = 0
$linesize  = 20

Write-host "ps-od - Windows file hex printer"
Write-host "Author: Mark Osborne"
Write-host "--------------------------------------------------------"
# Get content of  file for analysis
[Byte[]] $fileheader = Get-Content   -Path $file -Encoding Byte
       #
      # ForEach-Object {
 if ( $max -eq 0 ) {
           $max = $fileheader.count + 100
     }
# ForEach-Object loop
foreach ( $Bite in $fileheader ) {
             $a =  [char]  $Bite 
             if ( $a -match "[A-Za-z0-9]" ) {
                    # do nothing
                 }
              else
               {
                   $a =  [char]  " "
               } 
             $b = [int]  $Bite 
             if  ( $b -lt 16)
               {
                   $HeaderAsHexString +=  "0{0:X}" -f  $Bite 
                    # a little formating for single or double characters 
              }
          else
             {              
                   $HeaderAsHexString += "{0:X}" -f  $Bite 
                  # a little formating for single or double characters 
             }
        $HeaderAsHexString += " "
        $asciistring +=   $a + "  "
        $n++
 #    Get to the end of the line
        if ( $n -eq ($linesize  ) )
             {
                 write-host  "offset: " + $loop_cnt
                 write-host    $HeaderAsHexString
                 write-host     $asciistring
                 write-host " "
                $HeaderAsHexString = ""
                $asciistring  = ""
                $n =  0
                $loop_cnt = $loop_cnt + $linesize 
#              Where a count limit is provided
                if  ( $loop_cnt -gt $max) {
                      exit
                     }   
              }
       }

 # Write out the remains of last line 
if (  $asciistring -ne $null )
  {
      write-host  "offset: " + $loop_cnt
      write-host    $HeaderAsHexString
      $asciistring
  }

