<#
.SYNOPSIS

Powershell Most Recently Used list of office files

.DESCRIPTION

The ps-officeMRU is the Powershell  command that list the MRU registry key of the major office applications 

See:
 PowerShell for Malware Incident Response    Amazon Kindle eBook by MARK OSBORNE

.EXAMPLE

ps-officeMRU 

#>

param(    $app = "word" )
Write-host "ps-officeMRU -  lists the most recently opened  ms-office files from the appropriated  MRU registry key"
Write-host "Author: Mark Osborne"
Write-host "--------------------------------------------------------"
$applications = @( "word", "excel" , "powerpoint", "all")
# 
if  (  $app -in $applications ) {
write-host " Process files processed by "   $app
} else {
Write-host "Usage:"
Write-host "ps-officeMRU [-app [word|excel|powerpoint|all]]"
exit
}
$x1 = $null
$x2 = $null
$x3 = $null
if ( $app -eq "word"  -or $app -eq "all" )
{
write-host " Word documents recently used"
$x1  = Get-ChildItem "HKCU:\Software\Microsoft\office\[0-9.]*\Word\File MRU*"  -ErrorAction SilentlyContinue
write-host "     "
$x1
}

if ( $app -eq "excel"  -or $app -eq "all" )
{
write-host " Excel documents recently used"
$x2 = Get-ChildItem "HKCU:\Software\Microsoft\office\[0-9.]*\Excel\File MRU*"  -ErrorAction SilentlyContinue
write-host "            "
$x2
}

if ( $app -eq "powerpoint"  -or $app -eq "all" ) 
{
write-host " Powerpoint documents recently used"
$x3 = Get-ChildItem "HKCU:\Software\Microsoft\office\[0-9.]*\Powerpoint\File MRU*"  -ErrorAction SilentlyContinue
write-host "     "
$x3
}



