
<#

.SYNOPSIS

Powershell tail command


.DESCRIPTION

 This cmdlet is a Powershell tail command

See:
 PowerShell for Malware Incident Response    Amazon Kindle eBook by MARK OSBORNE

.PARAMETER   $l
No of lines to list from the end of file

This is an optional parameter.

.PARAMETER   $file
file to list 

.EXAMPLE
ps-tail .ps1 -l 10 myfile

List last ten lines of myfile


#>
# [CmdletBinding()]
param(   $l  ,  $file )
#
if   ( !( $l -match "[0-9]+" ) )   {
Write "-l must be numeric"
write "usage:"
Write "ps-tail -l number file"
exit
}
If    (  ! $l )  {
write-host "File or lines cannot be null"
write "usage:"
Write "ps-tail -l number file"
exit
}
 # validate file  object
If    ( ! $file  )  {
write-host "File or lines cannot be null"
write "usage:"
Write "ps-tail -l number file"
exit
}
If    ( ! (test-path $file)  ) {
write-host "File not found :  "  $file
write "usage:"
Write "ps-tail -l number file"
exit
}

Write-host "Ps-tail - Windows tail command "
Write-host "Author: Mark Osborne"
Write-host "--------------------------------------------------------"
 
# get-content  $file | select-object -last $l
get-content  $file -tail $l