<#

.SYNOPSIS

Powershell equivalent of  the Unix time command which displays elapse time of the command parameter

.DESCRIPTION

Powershell equivalent of  the Unix time command which displays elapse time of the command parameter

See:
 PowerShell for Malware Incident Response    Amazon Kindle eBook by MARK OSBORNE

.PARAMETER $cmdlet  

The path of command to be executed

This is an optional parameter.

.EXAMPLE

ps-time 

Prints the elapse time of the last command executed

.EXAMPLE

ps-time date 

Prints the elapse time of the date command executed

#>
param(   $cmdlet  )
#

Write-host "Ps-time.ps1 - Prints the elapse time of the last command executed"
Write-host "Author: Mark Osborne"
Write-host "--------------------------------------------------------"

#
if (  $cmdlet -eq $null ) {
$command = Get-History -Count 1  
Write "No Cmdlet - stats of the command follows  "  
$command
( $command.EndExecutionTime - $command.StartExecutionTime )
}
else
{
$t = Measure-Command {  iex $cmdlet }
Write-host "Total Seconds = "  $t.TotalSeconds

}